variables:
  GIT_SUBMODULE_STRATEGY: recursive

stages:
  - Building
  - Testing
  - ImageBuilding

.requirements_installation:
  image: ubuntu:latest
  before_script:
    - ./install_requirements.sh

Building:
  stage: Building
  extends: .requirements_installation
  script:
    - ./build.sh

Testing:
  stage: Testing
  extends: .requirements_installation
  script:
    - ./test.sh
  artifacts:
    name: 'TestsResults'
    paths:
      - TestsResults.xml

ImageBuilding:
  stage: ImageBuilding
  only:
    refs:
      - master
  image: docker:latest
  services:
    - "docker:dind"
  script:
    - IMAGE_TAG="$CI_REGISTRY_IMAGE:$(date -u +%Y.%m.%d.%H.%M.%S)"
    - echo "$CI_REGISTRY_PASSWORD" | docker login $CI_REGISTRY -u $CI_REGISTRY_USER --password-stdin
    - docker build -t $IMAGE_TAG .
    - docker push $IMAGE_TAG
